package thirdweekpractice.regexp;

public class RegexpTheory {
    /*
        1) Поиск текста:
        Текст: Java, java, java, program
        regexp: java
        Регулярные выражения регистрозависимые!
        заранее заданный текст, статический.

        2) Поиск любого символа:
        . - найдет любой символ (один).
        Текст:
        Аня
        Ася
        Оля
        Аля
        Валя
        Точка найдет и точку
        file.txt
        file1.txt
        file2.xls

        Найти все файлы с расширением .txt:
        Regexp: .txt
        Экранирование!
        \.txt
        . - любой символ
        \. - точка
        3) Поиск по набору символов
        Мы хотим найти имена Алла, Анна в списке.
        Можем попробовать через точку (две), но ...
        Regexp: А..а
        Анна
        Алла
        аолдо74пвлплт
        Аркан
        А:?а
        Абба

        Если мы хотим ограничить поиск, то нужно использовать диапозоны допустимых значений
        Ставим квадратные скобки, внутри перечисляем нужные нам символы:
        Regexp: А[нл][нл]а
        [нл] - только "н" и "л"
        [a-я] - все русские буквы в нижнем ригистре от "а" до "я" (кроме "ё")
        [А-Я] - все заглавные русские буквы.
        [А-Яа-яЁё] - все русские буквы
        [1-21] от 1 до 3 и цифра 1

        4) Исключения
        ^ внутри [] означает исключение
        [^0-9] - любой символ, кроме цифр
        [^ёЁ] - любой символ, кроме ёЁ

        regexp: [^0-9]\.txt
        file.txt
        log.txt
        file_1.txt
        1.txt
        скобки нельзя найти в тексте без экранирования \
        Regexp: fruits\[[0-9\]
        fruits[0] = "яблоко";
        fruits[1] = "апельсин";
        fruits[2] = "лимон";
        fruits["любое однозначное число"]

        5) Перечисление вариантов
        Квадратные скобки [] помогают перечислить варианты для одного символа.
        Если мы хотим перечислить слова, то лучше использовать вертикальную черту - |.

        regexp: Оля|Олечка|Котик
        Оля Олечка Оля Кот Котик

        Можно использовать вертикальную черту и для одного символа
        Можно даже внутри одного слова - тогда вариативную букву берем в круглые скобки.
        Пример:
        Regexp: А(н|л)я А[нл]я
         Настя
        Аня
        Аля
        Оля
        Катя
        6) Метасимволы
        Если мы хотим найти число, то пишем диапазон [0-9].
        Если букву, то [а-яА-ЯёЁa-zA-Z].
        В регулярных выражениях используют специальные символы метасимволы,
        которые заменяют собой корректный диапозон значений:
        таблица в дисе
        Символ  Эквивалент  Пояснение
   \d   [0-9]       Цифровой символ
   \D   [^0-9]      Нецифровой символ
   \s   [ \f\n\r\t\v]   Пробельный символ
   \S   [^ \f\n\r\t\v] Непробельный символ
   \w   [[:word:]]      Буквенный или цифровой символ или знак подчёркивания
   \W   [^[:word:]]     Любой символ, кроме буквенного или цифрового символа или знака подчёркивания


        мы хотим поработать с датами
        dd.mm.yyyy - формат даты
        11.10.1990
        11.56.asdf
        aa.23.18hf
        regexp: [0-9][0-9].[0-9][0-9].[0-9][0-9][0-9][0-9]
        \d\d\.\d\d\.\d\d\d\d

        7) Спецсимволы
        Большинство символов в регулярном выражении представляют сами себя за исключением
        специальных символов:
        [ ] { } / \ ^ $ . | ? * + ( )

        8) Квантификаторы (количество повторений)
        Символ "+" означает "одно или более повторений"
        Какие есть квантификаторы, кроме "+"?
        ? - ноль или одно
        * - ноль или более
        + - один или более
        ,* любой сисвол 0 или более раз

        Regexp (Хихи)*(Хаха)*
        ХихиХаха
        ХихиХихиХихи
        Хихи
        Хаха
        ХихиХихиХахаХахаХаха

        email:
        test@mail.ru
        olga31@gmail.com
        regexp: \w+@\w+\.\w+

        А что нужно, если мне необходимо определенное количество повторений, их нужно записать внутри фигурных скобок:

        {n} - ровно n раз
        {m,n} - от m до n включительно
        {m,} - не менее m
        {,n} - не более n
        Не забывайте квантификатор применяется к последнему символу

        Regexp: data{2} - нужно (data){2}
        dataa
        datadata


        Regexp: <.*> - XML формат смотрим
        Ожидание:
        <req>
        <query>Ан<\query>
        <gender>FEMALE</gender>
        Реальность:
        <req> <query>Ан</query> <gender>FEMALE</gender></req>


        1) Учитывать символы, не соответствующие желаемому образцу
        2) Определить квантификатор как нежадный (ленивый, англ. lazy) — большинство реализаций
        позволяют это сделать, добавив после него знак вопроса.

        Regexp: <[^>]*>

        Жадный      Ленивый
           *             *?
           +             +?
          {n,}          {n,}?

        9) Позиция внутри строки
        Если мы хотим найти конкретную фразу, а не слово, то используем след спец символы:
        ^ - начало текста (строки)
        $ - конец строки (строки)
        Regex ^Я нашел!$
        Смотри! Я нашел!
        Я нашел! Посмотри!

        10) Замена (replace)
        RegEx: Ольга
        Замена: Макар
        Текст был: Привет Ольга!
        Текст стал: Привет Макар!
        Владка плагина меняется на Replace
        RegEx: (Оля) \+ Маша
        Замена: через $1 - то что указано в круглых скобках
        Текст был: Оля + Маша
        Текст стал: Оля







     */
}
